=== debian/changelog ===
libjpeg-turbo (2.1.2-0ubuntu1) jammy; urgency=medium

  * New upstream version
  * debian/rules: set CMAKE_INSTALL_LIBDIR and remove some copy hacks as a
    result which also fix the pkgconfig libdir value (lp: #1851940)

 -- Sebastien Bacher <seb128@ubuntu.com>  Mon, 21 Feb 2022 15:20:30 +0100

libjpeg-turbo (2.1.1-0ubuntu1) jammy; urgency=medium

  * New upstream version.

 -- Robert Ancell <robert.ancell@canonical.com>  Wed, 17 Nov 2021 10:29:00 +1300

libjpeg-turbo (2.0.6-0ubuntu3) impish; urgency=medium

  * No-change rebuild to build packages with zstd compression.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Oct 2021 12:16:18 +0200

libjpeg-turbo (2.0.6-0ubuntu2) hirsute; urgency=medium

  * No-change rebuild to build with lto.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 28 Mar 2021 09:13:24 +0200

libjpeg-turbo (2.0.6-0ubuntu1) hirsute; urgency=medium

  * New upstream version.
  * Fix incorrect FLOATTEST guesses causing test failures. Closes: #966421.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 25 Feb 2021 14:00:46 +0100

libjpeg-turbo (2.0.3-0ubuntu2) groovy; urgency=medium

  * SECURITY UPDATE: Heap-based buffer over-read
    - debian/patches/CVE-2020-13790.patch: fix buf overrun caused
      by bad binary PPM in rdppm.c.
    - CVE-2020-13790

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Thu, 04 Jun 2020 13:06:27 -0300
